package de.unirostock.Builder.example.gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.SwingConstants;

import de.unirostock.Builder.example.OiltankerShipyard;
import de.unirostock.Builder.example.Ship;
import de.unirostock.Builder.example.Shipyard;
import de.unirostock.Builder.example.ToyShipyard;


public class GetShipPanel extends javax.swing.JPanel 
implements ActionListener
{
	private JLabel itsImgLabel;
	private JLabel itsLabInfoPower;
	private JLabel itsLabInfoMaterial;
	private JLabel itsLabInfoType;

	private final static String	BT_GET			= "BT_GET";
	
	private Ship itsShip;
	
	public GetShipPanel() {
		super();
		initGUI();
	}
	
	public void init( Shipyard shipyard ){
		itsImgLabel.setIcon( shipyard.getShipyardIcon());
		if( shipyard instanceof ToyShipyard )	itsShip	= ((ToyShipyard)shipyard).getShip();
		else									itsShip	= ((OiltankerShipyard)shipyard).getShip();
		setInfo( "","","" );
		repaint();
	}
	
	public void actionPerformed( ActionEvent e ){
		if( e.getActionCommand().equals( BT_GET )){
			setInfo( getShipCLassName(), itsShip.getMaterialType(), itsShip.getPower()+" PS" );
		}
		repaint();
	}
	
	private void setInfo( String type, String material, String power ){
		itsLabInfoType.setText( type );
		itsLabInfoMaterial.setText( material );
		itsLabInfoPower.setText( power );
	}
	
	private String getShipCLassName(){
		String	ship	= itsShip.getClass().getName();
		int		lastDot	= ship.lastIndexOf( '.' );
		return ship.substring( lastDot+1 );
	}
	
	private void initGUI() {
		try {
			this.setPreferredSize(new java.awt.Dimension(500, 300));
			GridBagLayout thisLayout = new GridBagLayout();
			thisLayout.columnWeights = new double[] {1.0,0.0,0.0,1.0};
			thisLayout.columnWidths = new int[] {1,0,0,1};
			thisLayout.rowWeights = new double[] {1.0,1.0,0.0,0.0,1.0};
			thisLayout.rowHeights = new int[] {7,7,7,7,7};
			this.setLayout(thisLayout);
			this.setBackground(new java.awt.Color(250,248,238));
			{
				itsImgLabel = new JLabel();
				this.add(itsImgLabel, new GridBagConstraints(
					1,
					0,
					2,
					1,
					0.0,
					0.0,
					GridBagConstraints.SOUTH,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0),
					0,
					0));
			}
			{
				JButton btGet = new JButton();
				this.add(btGet, new GridBagConstraints(
					1,
					1,
					2,
					1,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0),
					0,
					0));
				btGet.setText("getShip()");
				btGet.setActionCommand( BT_GET );
				btGet.addActionListener( this );
			}
			{
				JLabel labTextType = new JLabel();
				this.add(labTextType, new GridBagConstraints(
					1,
					2,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.LINE_START,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0),
					0,
					0));
				labTextType.setText("Schiffstyp:");
				labTextType.setPreferredSize(new java.awt.Dimension(80, 20));
				labTextType.setFont(new java.awt.Font("Arial",0,12));
			}
			{
				JLabel labTextMaterial = new JLabel();
				this.add(labTextMaterial, new GridBagConstraints(
					1,
					3,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.LINE_START,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0),
					0,
					0));
				labTextMaterial.setText("Material:");
				labTextMaterial.setPreferredSize(new java.awt.Dimension(80, 20));
				labTextMaterial.setFont(new java.awt.Font("Arial",0,12));
			}
			{
				JLabel labTextPower = new JLabel();
				this.add(labTextPower, new GridBagConstraints(
					1,
					4,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.FIRST_LINE_START,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0),
					0,
					0));
				labTextPower.setText("Leistung:");
				labTextPower.setPreferredSize(new java.awt.Dimension(80, 20));
				labTextPower.setFont(new java.awt.Font("Arial",0,12));
			}
			{
				itsLabInfoType = new JLabel();
				this.add(itsLabInfoType, new GridBagConstraints(
					2,
					2,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0),
					0,
					0));
				itsLabInfoType.setPreferredSize(new java.awt.Dimension(80, 20));
				itsLabInfoType.setText("");
				itsLabInfoType.setHorizontalAlignment(SwingConstants.RIGHT);
				itsLabInfoType.setFont(new java.awt.Font("Arial",1,12));
			}
			{
				itsLabInfoMaterial = new JLabel();
				this.add(itsLabInfoMaterial, new GridBagConstraints(
					2,
					3,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0),
					0,
					0));
				itsLabInfoMaterial.setText("");
				itsLabInfoMaterial.setPreferredSize(new java.awt.Dimension(80, 20));
				itsLabInfoMaterial.setHorizontalAlignment(SwingConstants.RIGHT);
				itsLabInfoMaterial.setFont(new java.awt.Font("Arial",1,12));
			}
			{
				itsLabInfoPower = new JLabel();
				this.add(itsLabInfoPower, new GridBagConstraints(
					2,
					4,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.FIRST_LINE_END,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0),
					0,
					0));
				itsLabInfoPower.setText("");
				itsLabInfoPower.setPreferredSize(new java.awt.Dimension(80, 20));
				itsLabInfoPower.setHorizontalAlignment(SwingConstants.RIGHT);
				itsLabInfoPower.setFont(new java.awt.Font("Arial",1,12));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
