/**
 * Created on 26.03.2005
 *
 * @author Jens Guenther
 */
package de.unirostock.Builder.example;

public abstract class Ship
{
	private Hull itsHull;
	private Engine itsEngine;

	protected void setEngine( Engine engine ) {
		itsEngine = engine;
	}
	
	protected void setHull( Hull hull ) {
		itsHull = hull;
	}
	
	public String getMaterialType() {
		if( itsHull == null )	return "";
		return itsHull.getMaterialType();
	}
	
	public float getPower() {
		if( itsEngine == null )	return 0;
		return itsEngine.getPower();
	}
}
