package de.unirostock.Builder.example.gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.SwingConstants;

import de.unirostock.Builder.example.OiltankerShipyard;
import de.unirostock.Builder.example.Shipyard;
import de.unirostock.Builder.example.ToyShipyard;


public class ChooseBuilderPanel extends javax.swing.JPanel 
implements ActionListener
{
	private ToyShipyard			itsToyShipyard			= new ToyShipyard();
	private OiltankerShipyard	itsOiltankerShipyard	= new OiltankerShipyard();
	
	private JRadioButton tBtShipyard;
	private JRadioButton tBtToyShipyard;

	private final static String	BT_TOY	= "BT_TOY";
	private final static String	BT_SHIP	= "BT_SHIP";
	
	public ChooseBuilderPanel() {
		super();
		initGUI();
	}
	
	public void actionPerformed( ActionEvent e ){
		if( e.getActionCommand().equals( BT_TOY )){
			if( tBtToyShipyard.isSelected())	tBtShipyard.setSelected( false );
			else								tBtShipyard.setSelected( true );
		}
		if( e.getActionCommand().equals( BT_SHIP )){
			if( tBtShipyard.isSelected())	tBtToyShipyard.setSelected( false );
			else							tBtToyShipyard.setSelected( true );
		}
	}
	
	public Shipyard getSelectedShipyard(){
		if( tBtToyShipyard.isSelected())	return itsToyShipyard;
		else								return itsOiltankerShipyard;
	}
	
	private void initGUI() {
		try {
			this.setPreferredSize(new java.awt.Dimension(500, 300));
			GridBagLayout thisLayout = new GridBagLayout();
			thisLayout.columnWeights = new double[] {0.1,1.0,0.1,1.0,0.1};
			thisLayout.columnWidths = new int[] {7,7,7,7,7};
			thisLayout.rowWeights = new double[] {0.1,0.1};
			thisLayout.rowHeights = new int[] {7,7};
			this.setLayout(thisLayout);
			this.setBackground(new java.awt.Color(250,248,238));
			{
				JLabel lImg = new JLabel();
				this.add(lImg, new GridBagConstraints(
					0,
					0,
					5,
					1,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0),
					0,
					0));
				lImg.setIcon(new ImageIcon(getClass().getClassLoader()
					.getResource("images/chooseShipyard.gif")));
			}
			{
				tBtToyShipyard = new JRadioButton();
				this.add(tBtToyShipyard, new GridBagConstraints(
					1,
					1,
					1,
					1,
					1.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.HORIZONTAL,
					new Insets(0, 0, 0, 0),
					0,
					0));
				tBtToyShipyard.setText("ToyShipyard");
				tBtToyShipyard.setActionCommand( BT_TOY );
				tBtToyShipyard.addActionListener(this);
				tBtToyShipyard.setBackground(new java.awt.Color(250,248,238));
				tBtToyShipyard.setHorizontalAlignment( SwingConstants.CENTER );
				tBtToyShipyard.setSelected(true);
				tBtToyShipyard.setPreferredSize(new java.awt.Dimension(100, 26));
			}
			{
				tBtShipyard = new JRadioButton();
				this.add(tBtShipyard, new GridBagConstraints(
					3,
					1,
					1,
					1,
					1.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.HORIZONTAL,
					new Insets(0, 0, 0, 0),
					0,
					0));
				tBtShipyard.setText("OiltankerShipyard");
				tBtShipyard.setActionCommand( BT_SHIP );
				tBtShipyard.addActionListener(this);
				tBtShipyard.setBackground(new java.awt.Color(250,248,238));
				tBtShipyard.setPreferredSize(new java.awt.Dimension(100, 26));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
