/*
 * Created on 12.08.2004
 *
 * @author Jens Guenther
 */
package de.unirostock.Builder.example.gui;


import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JPanel;

public class MainPanel extends JPanel 
{
	JPanel	itsHeadPanelContainer;
	JPanel	itsContentContainer;
	JPanel	itsButtonPanelContainer;

	/**
	 * 
	 * @uml.property name="mainHeadPanel"
	 * @uml.associationEnd multiplicity="(0 1)"
	 */
	MainHeadPanel itsMainHeadPanel;

	/**
	 * 
	 * @uml.property name="mainButtonPanel"
	 * @uml.associationEnd multiplicity="(0 1)"
	 */
	MainButtonPanel itsMainButtonPanel;

	public MainPanel()
	{
		initGraphics();
	}
	
	public void setHeadPanel( MainHeadPanel headPanel )
	{
		itsHeadPanelContainer.removeAll();
		itsHeadPanelContainer.add( headPanel );
		itsMainHeadPanel	= headPanel;
	}

	/**
	 * 
	 * @uml.property name="mainHeadPanel"
	 */
	public MainHeadPanel getMainHeadPanel() {
		return itsMainHeadPanel;
	}

	
	public void setContentPanel( JPanel contentPanel )
	{
		itsContentContainer.removeAll();
		itsContentContainer.add( contentPanel );
	}
	
	public void setButtonPanel( MainButtonPanel buttonPanel )
	{
		itsButtonPanelContainer.removeAll();
		itsButtonPanelContainer.add( buttonPanel );
		itsMainButtonPanel	= buttonPanel;
	}

	/**
	 * 
	 * @uml.property name="mainButtonPanel"
	 */
	public MainButtonPanel getMainButtonPanel() {
		return itsMainButtonPanel;
	}

	
	private void initGraphics()
	{
		setBackground( new Color( 255,255,255 ));
		
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout( gridbag );
		
		// head panel
		itsHeadPanelContainer	= new JPanel();
		itsHeadPanelContainer.setBackground( new Color( 255,255,255 ));
		c.weightx	= 1.0;
		c.weighty	= 0;
		c.fill		= GridBagConstraints.HORIZONTAL;
		c.gridwidth	= GridBagConstraints.REMAINDER;
		gridbag.setConstraints( itsHeadPanelContainer, c );
		add( itsHeadPanelContainer );
		
		// content panel
		itsContentContainer		= new JPanel();
		itsContentContainer.setBackground( new Color( 255,255,255 ));
		c.weighty	= 1.0;
		c.fill		= GridBagConstraints.BOTH;
		gridbag.setConstraints( itsContentContainer, c );
		add( itsContentContainer );
		
		// button panel
		itsButtonPanelContainer	= new JPanel();
		itsButtonPanelContainer.setBackground( new Color( 255,255,255 ));
		((FlowLayout)itsButtonPanelContainer.getLayout()).setAlignment( FlowLayout.CENTER );
		c.weighty	= 0;
		c.fill		= GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints( itsButtonPanelContainer, c );
		add( itsButtonPanelContainer );
	}
}
